N-Queen问题:无法弄清楚为什么我的解决方案不起作用

时间:2020-06-23 17:28:50

标签: c++ algorithm

我正在接受即将面试的标准N皇后问题。 我尝试空运行我的代码,它似乎运行良好。我无法在代码中发现错误。

我正在逐列遍历它,并使用回溯从错误的路径返回。 谁能为我提供帮助,为什么它不能提供所需的输出(详细信息如下)?

这里是problem statement

#include<bits/stdc++.h>
using namespace std;

void solve(vector<vector<int>> &ans, vector<int> &curr, int col, int n){
    if(col==n){
        ans.push_back(curr);
        return;
    }
    bool flag=false;
    
    for(int row=0; row<n; row++){
        if(col==0){
            curr.push_back(row);
            solve(ans, curr, col+1, n);
            curr.pop_back();
        }
        else{
            for(int i=0; i<curr.size(); i++){
                if((curr[i] == row) || (abs(row-curr[i]) == (col-i))){
                    flag=true;
                    break;
                }
            }
            if(flag)
                continue;
            curr.push_back(row);
            solve(ans, curr, col+1, n);
            curr.pop_back();
        }
    }
}

int main()
 {
    int t;
    cin>>t;
    while(t--){
        int n;
        cin>>n;
        vector<vector<int>> ans;
        vector<int> curr;
        solve(ans, curr, 0, n);
        for (int i = 0; i < ans.size(); i++) {
            cout << "[";
            for (int j = 0; j < ans[i].size(); j++) 
                cout << ans[i][j]+1 << " "; 
            cout << "]";
        }
        cout << endl;
    }
    return 0;
}

输入示例如下:

2
1
4

,相应的输出将是:

[1 ]
[2 4 1 3 ] [3 1 4 2 ]

编译器给我输出(用于我的代码):

[1 ]

3 个答案:

答案 0 :(得分:0)

bool flag变量(用于检查在(row, col)处放置一个女王/王后是否与curr中任何现有的女王/王后相交)目前正在各行中重复使用。

因此,如果将行bool flag=false;放在for(int i=0; i<curr.size(); i++){上方,它将为您的测试用例产生正确的输出。

其他说明:

  1. 创建单独的函数bool does_intersect(const vector<int>& cur, int row, int col)来检查皇后相交条件可能会更容易,这样就不需要bool flag变量。
  2. 可以删除if(col==0){条件,因为它不会执行else部分无法处理的任何事情。

答案 1 :(得分:0)

这是使用回溯法解决N-Queens问题的一种非常简单的方法:

import pygame
import time
import random
import math

pygame.init()

white = (255, 255, 255)
yellow = (255, 255, 102)
black = (0, 0, 0)
red = (213, 50, 80)
green = (0, 255, 0)
blue = (50, 153, 213)

dis_width = 600
dis_height = 400

dis = pygame.display.set_mode((dis_width, dis_height))
pygame.display.set_caption('Snake Game')

clock = pygame.time.Clock()

snake_block = 10
snake_speed = 15

font_style = pygame.font.SysFont("bahnschrift", 25)
score_font = pygame.font.SysFont("comicsansms", 35)


def Your_score(score):
value = score_font.render("Your Score: " + str(score), True, yellow)
dis.blit(value, [0, 0])



def our_snake(snake_block, snake_list):
for x in snake_list:
    pygame.draw.rect(dis, black, [x[0], x[1], snake_block, snake_block])
    
    
    
def Leftmove():
x1_change=-10
y1_change=0
x1+=x1_change
y1+=y1_change
return x1_change,y1_change

def Rightmove():
x1_change=10
y1_change=0
x1+=x1_change
y1+=y1_change
return x1_change,y1_change

def Topmove():
x1_change=0
y1_change=-10
x1+=x1_change
y1+=y1_change
return x1_change,y1_change

def Downmove():
x1_change=0
y1_change=10
x1+=x1_change
y1+=y1_change
return x1_change,y1_change

def nextMove(snake_head,x1_change,y1_change):
    
x1=snake_head[0]
y1=snake_head[1]
next_left=x1-10
next_right=x1+10
next_top=y1-10
next_down=y1+10
#print(next_left,next_right,next_top,next_down)

if next_left<0:
    Rightmove()
if next_right>= dis_width:
    Leftmove()
if next_top<0:
    Dowsnmove()
if next_down>=dis_height:
    Upmove()    
return x1_change,y1_change



    

def message(msg, color):
mesg = font_style.render(msg, True, color)
dis.blit(mesg, [dis_width / 6, dis_height / 3])


def GameBody():
while game_close!=False:
    dis.fill(blue)
    message("You Lost! Press C-Play Again or Q-Quit", red)
    Your_score(Length_of_snake - 1)
    pygame.display.update()

    for event in pygame.event.get():
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_q:
                game_close=False
                game_over = True
                return game_close,game_over
            if event.key == pygame.K_c:
                GameBody()

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            game_over = True
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_LEFT:
                x1_change = -10
                y1_change = 0
            elif event.key == pygame.K_RIGHT:
                x1_change = 10
                y1_change = 0
            elif event.key == pygame.K_UP:
                y1_change = -10
                x1_change = 0
            elif event.key == pygame.K_DOWN:
                y1_change = 10
                x1_change = 0
    
    
    
    
    if x1 >= dis_width or x1 < 0 or y1 >= dis_height or y1 < 0:
        game_close = True
    x1 += x1_change
    y1 += y1_change
    return x1,y1
    
    dis.fill(blue)
    pygame.draw.rect(dis, green, [foodx, foody, snake_block, snake_block])
    snake_Head = []
    snake_Head.append(x1)
    snake_Head.append(y1)
    snake_List.append(snake_Head)
    #print(snake_Head)
    #print(snake_List)
    if len(snake_List) > Length_of_snake:
        del snake_List[0]

   # Snake Hits Its Own Body    
    """
    for x in snake_List[:-1]:
        if x == snake_Head:
            game_close = True

    """
    our_snake(snake_block, snake_List)
    x1_change, y1_change = nextMove(snake_Head, x1_change, y1_change)
    Your_score(Length_of_snake - 1)
    pygame.display.update()
    
        
    #calculating distance
    def Distance():
        x=snake_Head[0]
        y=snake_Head[1]
        dis_fleft=foodx-x
        dis_fright=foody-y
        dis_food=foodx-x+foody-y
        print(dis_fleft,dis_fright,dis_food)
    Distance()

    

    if x1 == foodx and y1 == foody:
        foodx = round(random.randrange(0, dis_width - snake_block) / 10.0) * 10.0
        foody = round(random.randrange(0, dis_height - snake_block) / 10.0) * 10.0
        Length_of_snake += 1

    clock.tick(snake_speed)

game_over = False 
game_over = False
def gameLoop():

x1 = dis_width / 2
y1 = dis_height / 2

x1_change = 0
y1_change = 0

snake_List = []
Length_of_snake = 1

foodx = round(random.randrange(0, dis_width - snake_block) / 10.0) * 10.0
foody = round(random.randrange(0, dis_height - snake_block) / 10.0) * 10.0

while game_over!=True:
    GameBody()      
pygame.quit()
quit()


gameLoop()

这个想法是永远期待。将皇后放在矩阵中为0的插槽中。之后,在她可以移动到的所有插槽中添加1。当您从回溯中返回时,请从刚添加的插槽中减去1,然后继续尝试。

答案 2 :(得分:0)

此解决方案通过了LeetCode的N皇后问题在线判断,并使用三个标志来解决该问题:

#include <string>
#include <vector>

class Solution {
public:
    std::vector<std::vector<std::string>> solveNQueens(int n) {
        std::vector<std::vector<std::string>> possibilities;
        std::vector<std::string> n_queens(n, std::string(n, '.'));
        std::vector<int> flag_col(n, 1);
        std::vector<int> flag_diag_a(2 * n - 1, 1);
        std::vector<int> flag_diag_b(2 * n - 1, 1);
        solveNQueens(possibilities, n_queens, flag_col, flag_diag_a, flag_diag_b, 0, n);
        return possibilities;
    }

private:
    void solveNQueens(std::vector<std::vector<std::string>>& possibilities,
                      std::vector<std::string>& n_queens,
                      std::vector<int>& flag_col, std::vector<int>& flag_diag_a, std::vector<int>& flag_diag_b,
                      int row, int& n) {
        if (row == n) {
            possibilities.push_back(n_queens);
            return;
        }

        for (int col = 0; col != n; col++) {
            if (flag_col[col] && flag_diag_a[row + col] && flag_diag_b[n - 1 + col - row]) {
                flag_col[col] = flag_diag_a[row + col] = flag_diag_b[n - 1 + col - row] = 0;
                n_queens[row][col] = 'Q';
                solveNQueens(possibilities, n_queens, flag_col, flag_diag_a, flag_diag_b, row + 1, n);
                n_queens[row][col] = '.';
                flag_col[col] = flag_diag_a[row + col] = flag_diag_b[n - 1 + col - row] = 1;
            }
        }
    }
};

对于面试,您可能不应该使用:

#include<bits/stdc++.h>
using namespace std;

并确保编写干净的代码。


N Queens是一个低频面试问题。访谈中还有很多更好的问题要问(例如Number of Islands),可能您不会得到N个皇后区。但是,练习是很好的。